;Preview Image Capturer
;-------------------------------- 
;Ld ein Model welches danach in Pose gebracht werden kann,
;um ein Thumbnail/Preview Bild zu erstellen.
;
;ACHTUNG:	Thumbnail wird unter dem Dateinamen + ".bmp" gespeichert
;			Achte darauf, dass diese Datei nicht existiert sonst wird sie berschrieben
;
;
;STEUERUNG: Linke Maustaste drcken + Maus bewegen: Model bewegen
;			Rechte Maustaste drcken + Maus bewegen: Model drehen
;			Mausrad: ein-/auszoomen
;			1: Obere linke Ecke des Capturebereiches setzen (an der Position der Maus)
;			2: Untere rechte Ecke des Capturebereiches setzen (an der Position der Maus)
;			Enter: Bild 'capturen'. Bild wird danach oben links angezeigt und sofort gespeichert.


Const title$="Preview Image Capturer v1.1"

;-------------------------------- File Name (ohne .b3d Extension)
file$="kiwi"


;-------------------------------- File Path

path$="mods\Stranded II\gfx"
If FileType(path$)<>2 Then path$="."


;-------------------------------- Setup
set_scrx=800
set_scry=600
Graphics3D set_scrx,set_scry,32,2

;Filters
TextureFilter("_a",2)
TextureFilter("_m",4)
TextureFilter("_c",16+32)
TextureFilter("_hc",512)
TextureFilter("_sm",64)

;Cam
Global cam=CreateCamera()
CameraClsColor cam,0,0,0
reset_cam()
CameraRange cam,1,20000
SetBuffer BackBuffer()

;Light
ambl=192
AmbientLight ambl,ambl,ambl

p=CreatePivot()

sun1=CreateLight(1)
PositionEntity sun1,100,100,100
PointEntity sun1,p
LightColor sun1,128,128,128

;sun2=CreateLight(2)
;PositionEntity sun2,-100,100,-100
;PointEntity sun2,p
;LightColor sun2,255,255,255

CameraClsColor cam,0,0,0

;Image
Global x,y,w,h,image
image=CreateImage(40,40)
image_prev=CreateImage(40,40)

Global menu=0

Global files_pos=0
Global files_bar=0

Global menu_l=30

;-------------------------------- FX (Hier bei Bedarf das Model modifizieren!)
;EntityBlend mesh,3
;EntityShininess mesh,0.1
;EntityColor mesh,0,50,255

Global mesh
If FileType(path$+"\"+file$+".b3d")=1 Then
	mesh=LoadMesh(path$+"\"+file$+".b3d")
	ScaleEntity mesh,5,5,5
	EntityFX mesh,16
	;try to load current icon
	If FileType(path$+"\"+file$+".bmp") Then
		If image<>0 Then FreeImage image
		image=LoadImage(path$+"\"+file$+".bmp")
	Else
		If FileType("mods\Stranded II\gfx\defaulticon.bmp") Then
			image=LoadImage("mods\Stranded II\gfx\defaulticon.bmp")
		EndIf
	EndIf
EndIf

Global quit

Global debug=1

Type Tfile
	Field file$
	Field typ
End Type

Global TCfile.Tfile = New Tfile

Global files_n

Dim array_file$(0)
Dim array_typ(0)

;read dir!
opendir(path$)

Global dn_cache
Global up_cache
Global pgdn_cache
Global pgup_cache

Global select_quit=1

;-------------------------------- Runtime
While Not quit

	If menu=0 Then
		mxs=MouseXSpeed()
		mys=MouseYSpeed()
		mzs=MouseZSpeed()
		md1=MouseDown(1)
		md2=MouseDown(2)
	
		shift=KeyDown(42)
		
		f#=2.
		If shift Then f#=20.
	
		;rotate cam (hold right MB)
		If md2 Then RotateEntity cam,EntityPitch(cam)+mys,EntityYaw(cam)-mxs,EntityRoll(cam)
		
		If KeyDown(16) Then TurnEntity cam,0,0,1
		If KeyDown(18) Then TurnEntity cam,0,0,-1
	
;		If mzs<>0 Then TranslateEntity cam,0,0,mzs*f#
		If mzs<>0 Then MoveEntity cam,0,0,mzs*f#*10.
;		If md1 Then TranslateEntity cam,-mxs/5.,mys/5.,0
;		If md2 Then RotateEntity mesh,EntityPitch(mesh),EntityYaw(mesh)+mxs,EntityRoll(mesh)+mys

;		If KeyDown(2) Then x=MouseX():y=MouseY()
;		If KeyDown(3) Then w=MouseX()-x:h=MouseY()-y
	
		If KeyDown(17) Then MoveEntity cam,0,0,1.*f# ;w
		If KeyDown(30) Then MoveEntity cam,-1.*f#,0,0 ;a
		If KeyDown(31) Then MoveEntity cam,0,0,-1.*f# ;s
		If KeyDown(32) Then MoveEntity cam,1.*f#,0,0 ;d

		;c -> menu
		If KeyHit(46) Then menu=1

		;r -> reset cam
		If KeyHit(19) Then
			reset_cam()
		EndIf

		;ESC -> quit menu
		If KeyHit(1) Then
			select_quit=1
			menu=2
		EndIf

		If KeyHit(57) Or KeyDown(57) Then
			x=set_scrx/2-200:y=set_scry/2-200:w=400:h=400
			FreeImage(image_prev)
			image_prev=CreateImage(w-2,h-2)
			CopyRect(x+1,y+1,w-2,h-2,0,0,BackBuffer(),ImageBuffer(image_prev))
			TFormFilter 0
			ResizeImage image_prev,40,40
		EndIf

		;return
		If (KeyHit(28) Or KeyHit(156)) And progress_save=0 Then
			x=set_scrx/2-200:y=set_scry/2-200:w=400:h=400
			FreeImage(image)
			image=CreateImage(w-2,h-2)
			CopyRect(x+1,y+1,w-2,h-2,0,0,BackBuffer(),ImageBuffer(image))
			TFormFilter 0
			ResizeImage image,40,40
;			DebugLog("save: "+path$+"\"+file$+".bmp")
			SaveImage(image,path$+"\"+file$+".bmp")
			progress_save=20
		ElseIf progress_save>0 Then
			progress_save=progress_save-1
		EndIf

		;light	
		If KeyHit(44) Then ambl=ambl-50
		If KeyHit(45) Then ambl=ambl+50
		If ambl<50 Then ambl=50
		If ambl>255 Then ambl=255
		AmbientLight ambl,ambl,ambl
	ElseIf menu=1
		;esc
		If KeyHit(1) Then
			progress_save=0
			menu=0
		EndIf
		If menu=1 Then
			If KeyHit(200) Or up_cache>30 Then ;up
				If files_bar>0 Then
					files_bar=files_bar-1
				ElseIf files_pos>0 Then
					files_pos=files_pos-1
				EndIf
			EndIf
			If KeyHit(208) Or dn_cache>30 Then ;down
				If files_bar<menu_l-1 Then
					files_bar=files_bar+1
					If files_bar>files_n-1 Then files_bar=files_n-1
				ElseIf files_pos+menu_l<files_n-1 Then
					files_pos=files_pos+1
				EndIf
			EndIf
			;up/down (hold...)
			If KeyDown(200) Then
				up_cache=up_cache+1
			Else
				up_cache=0
			EndIf
			If KeyDown(208) Then
				dn_cache=dn_cache+1
			Else
				dn_cache=0
			EndIf
			;pos1
			If KeyHit(199) Then
				files_bar=0
				files_pos=0
			EndIf
			;end
			If KeyHit(207) Then
				files_pos=files_n-menu_l
				files_bar=menu_l-1
				If files_bar>files_n-1 Then files_bar=files_n-1
			EndIf
			;pgup
			If KeyHit(201) Or pgup_cache>30 Then
				files_pos=files_pos-menu_l
				If files_pos<0 Then
					files_bar=0
					files_pos=0
				EndIf
			EndIf
			;pgdn
			If KeyHit(209) Or pgdn_cache>30 Then
				files_pos=files_pos+menu_l
				If files_pos+menu_l>files_n-1 Then
					files_pos=files_n-menu_l
					files_bar=menu_l-1
					If files_bar>files_n-1 Then files_bar=files_n-1
				EndIf
			EndIf
			;pgup/pgdn (hold...)
			If KeyDown(201) Then
				pgup_cache=pgup_cache+1
			Else
				pgup_cache=0
			EndIf
			If KeyDown(209) Then
				pgdn_cache=pgdn_cache+1
			Else
				pgdn_cache=0
			EndIf
			;backspace
			If KeyHit(14) Then
				If path$<>"mods" Then
					;cut...
					Local tmp$=""
					For k=Len(path$) To 1 Step -1
						tmp$=Mid(path$,1,k)
						If Mid(path$,k,1)="\" Then
							tmp$=Mid(path$,1,k-1)
							Exit
						EndIf
					Next
					path$=tmp$
					opendir(path$)
					files_bar=0
					files_pos=0
				EndIf
			EndIf
			;return
			If (KeyHit(28) Or KeyHit(156)) Then
				Select TCfile\typ
					Case 1
;						DebugLog("old file: "+file$)
;						DebugLog("new file: "+stripext(TCfile\file$,1))

						file$=stripext(TCfile\file$,1)
						If FileType(path$+"\"+file$+".b3d")<>1 Then RuntimeError("NO FILE "+path$+file$+".b3d")
						FreeEntity mesh
						mesh=LoadMesh(path$+"\"+file$+".b3d")
						ScaleEntity mesh,5,5,5
						EntityFX mesh,16
						If image_prev<>0 Then FreeImage(image_prev)
						image_prev=CreateImage(40,40)
						;try to load current icon
						If FileType(path$+"\"+file$+".bmp") Then
							If image<>0 Then FreeImage image
							image=LoadImage(path$+"\"+file$+".bmp")
						Else
							image=LoadImage("mods\Stranded II\sys\gfx\defaulticon.bmp")
						EndIf
					Case 2
						If TCfile\file$<>".." Then
;							DebugLog("old path: "+path$)
;							DebugLog("new path: "+path$+"\"+TCfile\file$)
							path$=path$+"\"+TCfile\file$
							opendir(path$)
							files_bar=0
							files_pos=0
						Else
							If path$<>"mods" Then
								;cut...
								tmp$=""
								For k=Len(path$) To 1 Step -1
									tmp$=Mid(path$,1,k)
									If Mid(path$,k,1)="\" Then
										tmp$=Mid(path$,1,k-1)
										Exit
									EndIf
								Next
								path$=tmp$
								opendir(path$)
								files_bar=0
								files_pos=0
							EndIf
;							DebugLog("old path: "+path$)
;							DebugLog("new path: "+tmp$)
						EndIf
				End Select
			EndIf
		EndIf
	ElseIf menu=2
		;ESC -> quit		
		If KeyHit(1) Then menu=0
		If (KeyHit(28) Or KeyHit(156)) Then
			If select_quit Then
				quit=1
			Else
				menu=0
			EndIf
		EndIf
		If KeyHit(200) Or KeyHit(208) Then select_quit=1-select_quit
	EndIf
	
	RenderWorld()

	If menu=1 Then
		Local i=0
		Local offset=set_scry/2-(12*menu_l/2)
		;first list dirs...
		For Tfile.Tfile=Each Tfile
			If Tfile\typ=2 Then
				If i>=files_pos And i<files_pos+menu_l Then
					Color 255,255,255
					If i-files_pos=files_bar Then
						Rect 0,(i-files_pos)*12+offset,195,12
						Color 0,0,128
						Text 0,(i-files_pos)*12+offset,Tfile\file$
						TCfile=Tfile
					Else
						Text 0,(i-files_pos)*12+offset,Tfile\file$
					EndIf
				EndIf
				i=i+1
			EndIf
		Next
		;...then files
		For Tfile.Tfile=Each Tfile
			If Tfile\typ=1 Then
				If i>=files_pos And i<files_pos+menu_l Then
					Color 255,255,255
					If i-files_pos=files_bar Then
						Rect 0,(i-files_pos)*12+offset,195,12
						Color 0,0,128
						Text 0,(i-files_pos)*12+offset,Tfile\file$
						TCfile=Tfile
					Else
						Text 0,(i-files_pos)*12+offset,Tfile\file$
					EndIf
				EndIf
				i=i+1
			EndIf
		Next
		Color 255,255,255
		Rect x,y,w,h,0
		Rect set_scrx/2-200,set_scry/2-200,400,400,0
		Rect set_scrx-42,0,42,42,0
		Rect set_scrx-42,45,42,42,0
		DrawImage image,set_scrx-41,1
		DrawImage image_prev,set_scrx-41,46
		Text 0,set_scry-3*12,"navigate through list       : UP,DN,PGUP,PGDN,POS1,END,<--"
		Text 0,set_scry-2*12,"select file/change directory: RETURN"
		Text 0,set_scry-1*12,"return to capture mode      : ESC"
;		Text 0,set_scry-4*12,
;		Text 0,set_scry-12,TCfile\file$
	ElseIf menu=0
		Rect x,y,w,h,0
		If progress_save Then Color 0,128,0
		Rect set_scrx/2-200,set_scry/2-200,400,400,0
		Color 255,255,255
		Rect set_scrx-42,0,42,42,0
		Rect set_scrx-42,45,42,42,0
		DrawImage image,set_scrx-41,1
		DrawImage image_prev,set_scrx-41,46
		Color 0,192,0
		If progress_save>0 Then Text set_scrx/2-35,set_scry/2+202,"[ SAVED ]"
		Color 255,255,255
		Text 0,set_scry-7*12,"W,A,S,D to move, right MB to look around, SHIFT for faster movement"
		Text 0,set_scry-6*12,"Q/R - roll camera"
		Text 0,set_scry-5*12,"Z/X - ambient light (Y/X for german tastatur layout)"
		Text 0,set_scry-4*12,"R - reset camera"
		Text 0,set_scry-3*12,"C - choose file"
		Text 0,set_scry-2*12,"SPACE - preview, RETURN - save icon"
		Text 0,set_scry-1*12,"ESC - Quit"
	ElseIf menu=2
		Text set_scrx/2-24,set_scry/2-18,"Quit?"
		If select_quit Then
			Rect set_scrx/2-24,set_scry/2-2,48,12,1
			Color 0,0,128
			Text set_scrx/2-24,set_scry/2-2,"Okay"
			Color 255,255,255
			Text set_scrx/2-24,set_scry/2+12-2,"Cancel"
		Else
			Rect set_scrx/2-24,set_scry/2-2+12,48,12,1
			Text set_scrx/2-24,set_scry/2-2,"Okay"
			Color 0,0,128
			Text set_scrx/2-24,set_scry/2+12-2,"Cancel"
			Color 255,255,255
		EndIf
		Line set_scrx/2-26,set_scry/2-4,set_scrx/2+24,set_scry/2-4
		Rect set_scrx/2-26,set_scry/2-18,52,42,0
	EndIf
	Text set_scrx/2-107,0,title$
	Line set_scrx/2-110,14,set_scrx/2+110,14
	Line set_scrx/2-110,16,set_scrx/2+110,16
		
	Flip
	
Wend

;### Strip Filename
Function filename$(txt$)
	p=Instr(txt$,".")
	If p<>0 Then
		Return(Left(txt$,p-1))
	Else
		Return(txt$)
	EndIf
End Function

;### Strip Extension
Function stripext$(txt$,mode=0)
	p=Instr(txt$,".")
	;filename
	If mode Then
		If p>0 Then
			Return Mid(txt$,1,p-1)
		EndIf
	;extension (without '.')
	Else
		If p<>0 Then Return Mid(txt$,p+1,Len(txt$)-3)
	EndIf
	Return ""
End Function

Function opendir(path$,debug=0)
	For Tfile.Tfile=Each Tfile:Delete Tfile:Next
	files_n=0
	Local dir
	Local i
	Local file_type
	Local tmp$
	Local txt$
	dir=ReadDir(path$)
	Repeat
		tmp$=NextFile(dir)
		If tmp$="" Then Exit
		file_type=0
		If debug Then
			DebugLog(path$+"\"+tmp$)
		EndIf
		If FileType(path$+"\"+tmp$)=2 And tmp$<>"." Then
			file_type=2
			tmp$=Upper(tmp$)
		ElseIf stripext(tmp$)="b3d" Then
			file_type=1
		EndIf
		If file_type>0 Then
			files_n=files_n+1
			Tfile.Tfile = New Tfile
			Tfile\file$=tmp$
			Tfile\typ=file_type
		EndIf
	Forever
	CloseDir(dir)
;	sortfiles()
End Function

Function sortfiles()
	Local i=0
	Dim array_file$(files_n)
	Dim array_typ(files_n)
	For Tfile.Tfile=Each Tfile
		array_file$(i)=Tfile\file$
		array_typ(i)=Tfile\typ
		i=i+1
	Next
	For i=0 To files_n
		DebugLog(array_file$(i)+" ("+array_typ(i)+")")
	Next
	quicksort(0,files_n)
End Function

Function quicksort(lf,rt)
	Local ce
	If lf<rt Then
		ce=merge(lf,rt)
		quicksort(lf,ce-1)
		quicksort(ce+1,rt)
	EndIf
End Function

Function merge(lf,rt)
	Local i=lf
	Local j=rt-1
	Local pivot$=stripext$(array_file$(rt),1)
	While i<j
;		While array(i)<=pivot And i<rt
		While i<rt And cmpstr(stripext$(array_file$(i),1),pivot$)
			i=i+1
		Wend
		While j>lf And cmpstr(pivot$,stripext$(array_file$(j),1))
			j=j-1
		Wend
		If i<j Then
			tmps$=array_file$(i)
			array_file$(i)=array_file$(j)
			array_file$(j)=tmps$
			tmp=array_file(i)
			array_typ(i)=array_typ(j)
			array_typ(j)=tmp
		EndIf
	Wend
	If cmpstr(stripext$(array_file$(i),1),pivot$)=0 Then
		tmps$=array_file$(i)
		array_file$(i)=array_file$(rt)
		array_file$(rt)=tmps$
		tmp=array_file(i)
		array_typ(i)=array_typ(rt)
		array_typ(rt)=tmp
	EndIf
	Return i
End Function

;stripext$(txt$,1)

Function cmpstr(lf$,rt$)
	Local len1=Len(lf$)
	Local len2=Len(rt$)
	Local n=len1
	If n>len2 Then n=len2
	For i=1 To n
		If Asc(Mid(lf$,i,1))>Asc(Mid(rt$,i,1)) Then Return 0
	Next
	Return 1
End Function

Function reset_cam()
	PositionEntity cam,0,0,-50
	RotateEntity cam,0,0,0
End Function